# pftruth-standalone

## Run the application
The input to the merging algorithm is provided via the `pftruth.cc` source file.
The application has been tested with `ROOT 6.26.04` and it is compilable using the `Makefile` placed in the current directory. Once the compilation is done, you can run
the application as follows:

```
./pftruth
```

The output of the merging is stored in the `mergedClusters.root`.

## Generating samples with python
To generate ad-hoc samples you can use the Python scripts placed in the `data/` directory. Through the `data/config.yml` file you can set the parameters for the sample generation and the path for the `.csv` files needed for the standalone application itself. As an example here are the setting for the clusters we would like to generate:

```yml
clusters:
  centers: [[0, 0], [1, 1], [2, 2]]
  std: [1.0, 1.0, 1.0]
  n_samples: [100, 100, 100]
  csv_path: "simClusters.csv"
```

When you are happy with your configuration you can run `data/makeSamples.py` that will produce the `.csv` files in the path you specified. 

## Running the entire workflow
Using the `run-workflow.sh` script allows us to run both generation and merging steps at once. For its usage run 

```bash
./run-workflow.sh -h
```
