import numpy as np
import os
import datetime

def generateConfig(nEvents):
    config_dir = os.environ['CONFIG_DIRECTORY']
    csv_dir = os.environ['CSV_DIRECTORY'].replace('csv', 'tmp')
    if not os.path.exists(csv_dir):
        os.makedirs(csv_dir)
    for i in range(0, nEvents):
        centers_a, std_a, nsamples_a, genParticle_a = [], [], [], []
        with open(config_dir+'/config_%d.yml' % i, 'w') as file:
            nParticles = np.random.randint(5, 15)
            charge = np.random.choice([-1, 0, 1], nParticles)
            tCharges, tParticles = [], []
            for particle in range(nParticles):
                nClusters = np.random.randint(1, 4)
                if charge[particle] != 0:
                  totalTrackCharge = -2
                  while totalTrackCharge != charge[particle]:
                    trackCharges = np.random.choice([-1, 0, 1], nClusters)
                    totalTrackCharge = np.sum(trackCharges)
                  trackParticles = [particle for _ in range(nClusters)]
                  tCharges.append(trackCharges)
                  tParticles.append(trackParticles)
                centers = [[np.random.uniform(-0.25, 0.25), np.random.uniform(-0.25, 0.25)] for _ in range(nClusters)]
                std = [np.random.uniform(0.01, 0.03) for _ in range(nClusters)]
                nSamples = [np.random.randint(500, 50000) for _ in range(nClusters)]
                genParticle = [particle for _ in range(nClusters)]
                centers_a.append(centers)
                std_a.append(std)
                nsamples_a.append(nSamples)
                genParticle_a.append(genParticle)

            file.write('pfparticles:\n')
            file.write('  charge: [\n')
            for c in charge:
              file.write('      %d,\n' % c)
            file.write('  ]\n')
            file.write('  csv_file: "%s/pfparticles%s.csv"\n' % (csv_dir, '_'+str(i)))
            file.write('clusters:\n')
            file.write('  centers: [\n')
            for centers in centers_a:
                for center in centers:
                    file.write('      [%f, %f],\n' % (center[0], center[1]))
            file.write('  ]\n')
            file.write('  std: [\n')
            for std in std_a:
                for s in std:
                    file.write('      %f,\n' % s)
            file.write('  ]\n')
            file.write('  n_samples: [\n')
            for nSamples in nsamples_a:
                for n in nSamples:
                    file.write('      %d,\n' % n)
            file.write('  ]\n')
            file.write('  pfparticles: [\n')
            for genParticle in genParticle_a:
                for g in genParticle:
                    file.write('      %d,\n' % g)
            file.write('  ]\n')
            file.write('  csv_file: "%s/simClusters%s.csv"\n' % (csv_dir, '_'+str(i)))
            file.write('hits:\n')
            file.write('  bins:\n')
            file.write('    start: -0.3\n')
            file.write('    end: 0.3\n')
            file.write('    n_bins: 50\n')
            file.write('  csv_file: "%s/hits%s.csv"\n' % (csv_dir, '_'+str(i)))
            file.write('simHits:\n')
            file.write('  csv_file: "%s/simHits%s.csv"\n' % (csv_dir, '_'+str(i)))
            file.write('tracks:\n')
            file.write('  charges: [\n')
            for trackCharge in tCharges:
                for charge in trackCharge:
                    file.write('      %d,\n' % charge)
            file.write('  ]\n')
            file.write('  pfparticles: [\n')
            for track_particle in tParticles:
                for particle in track_particle:
                    file.write('      %d,\n' % particle)
            file.write('  ]\n')
            file.write('  csv_file: "%s/tracks%s.csv"\n' % (csv_dir, '_'+str(i)))
            file.write('vertices:\n')
            file.write('  csv_file: "%s/vertices%s.csv"\n' % (csv_dir, '_'+str(i)))
        file.close()

    
