#include "../interface/SimCluster.h"

void SimCluster::addG4Tracks(const SimTrack &t) {
  g4Tracks_.push_back(t);
  if (g4Tracks_.size() == 1)
    pdgId_ = t.type();
  else
    pdgId_ = 0;
}

SimCluster SimCluster::operator+(SimCluster &toAdd) {
  SimCluster orig = *this;
  return orig += toAdd;
}

SimCluster SimCluster::operator+=(SimCluster &toMerge) {
  for (auto &track : toMerge.g4Tracks())
    this->addG4Tracks(track);

  for (auto &hit_and_e : toMerge.hits_and_fractions())
    this->addRecHitAndFraction(hit_and_e.first, hit_and_e.second);

  auto mergeMom = toMerge.impactMomentum();
  float sumE = impactMomentum_.E() + mergeMom.E();
  this->impactPoint_ = (this->impactPoint_ * this->impactMomentum_.E() +
                        toMerge.impactPoint() * mergeMom.E()) /
                       sumE;

  this->impactMomentum_ += mergeMom;
  this->positionAtBoundary_ += toMerge.positionAtBoundary();
  this->energy_ += toMerge.energy();
  pdgId_ = 0;
  return *this;
}
